import config as cf

import numpy as np

def sample_scen_f(n_ins, distribution, demand_mean, stop):

    if distribution == 'normal':
        demand_matrix = [[0 for col in range(cf.T+1)] for row in demand_mean.index]
        for row in cf.pickup[n_ins]:
            for col in range(cf.T):
                val = np.random.normal(loc=demand_mean.iat[row,col],
                                       scale=cf.demand_variance_proportion*demand_mean.iat[row,col])
                val = round(val)
                if val >= 0.01:
                    demand_matrix[row][col+1] = val
                else:
                    demand_matrix[row][col+1] = 0
    return(demand_matrix)