def argmax_f(my_dict):
    my_list = [key for (key, val) in sorted(my_dict.items(),
                                            key=lambda x:x[1],
                                            reverse=False)]
    return my_list.pop()

def argmin_f(my_dict):
    my_list = [key for (key, val) in sorted(my_dict.items(),
                                            key=lambda x:x[1],
                                            reverse=True)]
    return my_list.pop()

def max_f(my_dict):
    my_list = [val for (key, val) in sorted(my_dict.items(),
                                            key=lambda x:x[1],
                                            reverse=False)]
    return my_list.pop()


def hire_car_f(i_car, i_demand, E, S_H, q_rem, q_rem_h, a_rem, a_rem_tot):
    s_h = argmax_f({s: q_rem[s] for s in E[i_car]})
    S_H.append(s_h)
    E[i_car].remove(s_h)
    q_rem_h += q_rem[s_h]
    q_rem, q_rem_h, a_rem, a_rem_tot = fill_car_f(s_h, i_demand, q_rem, 
                                                  q_rem_h, a_rem, a_rem_tot)
    return E, S_H, q_rem, q_rem_h, a_rem, a_rem_tot
    
def fill_car_f(s, i, q_rem, q_rem_h, a_rem, a_rem_tot):
    if q_rem[s] <= a_rem[i]:
        a_rem[i] = a_rem[i] - q_rem[s]
        a_rem_tot = a_rem_tot - q_rem[s]
        q_rem_h = q_rem_h - q_rem[s]
        q_rem[s] = 0
    else:
        q_rem[s] = q_rem[s] - a_rem[i]
        a_rem_tot = a_rem_tot - a_rem[i]
        q_rem_h = q_rem_h - a_rem[i]
        a_rem[i] = 0
   
    return q_rem, q_rem_h, a_rem, a_rem_tot